/*
 * Copyright 1995 by the Massachusetts Institute of Technology.
 * All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the name of
 * M.I.T. not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior
 * permission.  M.I.T. makes no representations about the suitability
 * of this software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */
/* %%%EOOH%%% */

#include <stdio.h>
#include "Error.h"

/*
 * ERRORS:
 *
 * GENERAL_NULLPOINTER: FATAL
 * A null pointer was passed to the routine %s.
 *
 * GENERAL_MALLOC: FATAL
 * malloc failed to get %d bytes.
 */

void Error_Pop()
{
  if (Error_StackTop != 0)
    {
      if (Error_InfoMalloced)
	free(Errur[Error_StackTop].description);
      Error_StackTop--;
    }
}

void Error_Push(e, d)
     Card32 e;
     caddr_t d;
{
  if (Error_StackTop == ERRORDEPTH - 1)
    {
      fprintf(stderr, "Warning: error stack overflow\n");
      Error_Pop();
    }

  Error_StackTop++;
  Errur[Error_StackTop].error = e;
  Errur[Error_StackTop].description = d;
}
