/*
 * Copyright 1995 by the Massachusetts Institute of Technology.
 * All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the name of
 * M.I.T. not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior
 * permission.  M.I.T. makes no representations about the suitability
 * of this software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */
/* %%%EOOH%%% */

#define CODEDOMAIN "literal"
#define PORTDOMAIN "inet-udp"
#define PORTPROTO "udp"
#define PORTNUMBER 3716
#define PORTNAME "slw"
#define SLOCNAME "slw"
#define SLOC "sloc"

#define MAXSERVERS 5
#define NUMRETRIES 5
#define RETRY 500 /* ms */

#define TIMERANGE 300

#define PROTOVERSION0 0

#define REQUEST_PING 1
#define REQUEST_REGISTRATION 2
#define REQUEST_DEREGISTRATION 3
#define REQUEST_KEY 4
#define REQUEST_OPEN 5
#define REQUEST_CLOSE 6

#define REPLY_ERROR 0
#define REPLY_PING 1
#define REPLY_REGISTRATION 2
#define REPLY_DEREGRISTRATION 3
#define REPLY_KEY 4
#define REPLY_OPEN 5
#define REPLY_CLOSE 6

#define ERROR_BADPACKET 1
#define ERROR_PROTOUNSUPPORTED 2
#define ERROR_BADREQUEST 3
#define ERROR_BADKEYGENERATOR 4
#define ERROR_PERMISSIONDENIED 5
#define ERROR_UNKNOWNKEY 6
#define ERROR_UNKNOWNKEYTYPE 7
#define ERROR_NOKEYSAVAIL 8

extern char *requests[];
extern char *replies[];
extern char *errors[];
